# Filters added to this controller will be run for all controllers in the application.
# Likewise, all the methods added will be available for all controllers.
require_dependency "login_system"
class ApplicationController < ActionController::Base
  include LoginSystem
  prepend_before_filter :time_stamp

  def time_stamp
    if session[:user] && session[:timestamp] && Time.now - session[:timestamp] > GFDNAVI_SESSION_DURATION*60
      session[:user] = nil
      flash[:notice] = "Automatically logout because long time was passed without  your access"
    end
    session[:timestamp] = Time.now
  end

  def user_path
    GFDNAVI_USER_PATH + "/" + session[:user].login
  end

  def debug(obj)
    obj = obj.inspect unless String === obj
    STDERR.print obj,"\n" if GFDNAVI_DEBUG
  end

end
