class Directory < ActiveRecord::Base
#  has_many :variables, :order => "name"

  has_many :keyword_attributes, :dependent => :destroy
  has_many :spatial_attributes, :dependent => :destroy
  acts_as_tree :order => "name"
  validates_presence_of :name

  def self.find_for_user_by_id(user, id)
    dir = self.find(id)
    var = Variable.find_for_user(user, :first, :conditions => ["path LIKE ?", dir.path+"%"])
    var.nil? ? nil : dir
  end

  def self.find_for_user(user, *args)
    dir = self.find(*args)
    if dir.is_a?(ActiveRecord::Base)
      var = Variable.find_for_user(user, :first, :conditions => ["path LIKE ?", dir.path+"%"])
      var.nil? ? nil : dir
    elsif dir.nil?
      nil
    else
      dirs = Array.new
      dir.each do |d|   # dir is actually an Array
	var = Variable.find_for_user(user, :first, :conditions => ["path LIKE ?", d.path+"%"])
	dirs.push(d) if var
      end
      dirs
    end
  end

#  def children
#    raise NoMethodError, "This meshod is disabled. Use children_for_user."
#  end

  def children_for_user(user, flag=false)
    @children_for_user_hash ||= Hash.new
    if flag || @children_for_user_hash[user].nil?
      grp_cond = Group.group_conditions(user,"var")
      dir_path = connection.adapter_name=="MySQL" ? "concat(dir.path,'%')" : "dir.path||'%'"
      sql = <<-EOS
        SELECT DISTINCT dir.*
        FROM directories AS dir, variables AS var
        WHERE dir.parent_id=? AND var.path LIKE #{dir_path} AND #{grp_cond}
      EOS
      records = Directory.find_by_sql([sql,id])
      records.each { |record| record.readonly! }
      @children_for_user_hash[user] = records
    end
    @children_for_user_hash[user]
  end

  def variables
    raise NoMethodError, "This meshod is disabled. Use variables_for_user."
  end
  def variables_for_user(user)
    Variable.find_for_user(user, :all, :conditions=>"directory_id = #{self.id}")    
  end

  def downloadable?
    return false unless plain_file
    flag = true
    dir = self
    while (dir)
      if dir.keyword_attributes.count('name="download" AND value="disable"') > 0
        return false
      end
      dir = dir.parent
    end
    return true
  end

end
